;///////////////////////////////////////////////////////////////////////////////////////////////////
;/							    NoAPD 1.1-APD prevention										   /
;/							Written by Donald Straney 6/3/03									   /
;/					Designed for the Z80/TI-86 graphing calculator								   /
;///////////////////////////////////////////////////////////////////////////////////////////////////

#include "ti86asm.inc"

.org _asm_exec_ram

  nop								;Display shell title
  jp ProgStart

.dw 0,ShellTitle

ShellTitle: .db "Control APD",0

ProgStart:
  call _clrLCD					;Clear screen
  call _homeup					;Set cursor to top-left of screen
  set textInverse,(iy+textflags)		;Set for inverse text
  ld hl,Title					;Display title
  call _puts
  res textInverse,(iy+textflags)		;Set back to normal text for keypress messages
  call _newline					;Display keypress messages
  call _newline
  ld hl,APD_Str					;Display first part of APD indicator string
  call _puts
  call _newline
  ld hl,Key1
  call _puts
  call _newline
  ld hl,Key2
  call _puts
  jr Refresh					;Show whether on or off

Key_Loop:
  call _getkey					;Wait for keypress
  sub $07						;If exit is pressed, then return
  ret z
  sub $bb						;If f1 is pressed, then enable APD
  jr z,Enable
  dec a							;If f2 is pressed, then disable APD
  jr z,Disable
  jr Key_Loop					;If none of these, wait some more

Enable:							;Enable APD
  set 2,(iy+8)
  jr Refresh

Disable:						;Disable APD
  res 2,(iy+8)

Refresh:
  ld hl,$0402					;Position cursor
  ld (_curRow),hl
  bit 2,(iy+8)					;Check if APD is on or off
  jr z,APD_Off					;If off, display off string
APD_On:
  ld hl,ON_Str					;Set to display on string
  jr End_Refresh
APD_Off:						;Set to display off string
  ld hl,OFF_Str
End_Refresh:
  call _puts					;Draw
  jr Key_Loop					;Now wait for another keypress

Title: .db "  NoAPD version 1.1  ",0	;Title bar text
Key1: .db "F1 to enable APD",0			;Keypress messages
Key2: .db "F2 to disable APD",0
APD_Str: .db "APD:",0					;APD indicator messages
ON_Str: .db "ON ",0
OFF_Str: .db "OFF",0

.end
END